"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
/*! *****************************************************************************
Copyright (c) 2016 Tangra Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
***************************************************************************** */
var common = require("./client-common");
var application = require("application");
var table_1 = require("../table");
var user_1 = require("../user");
var push_1 = require("../push");
__export(require("./client-common"));
var nativeAuthenticationProviders = [];
nativeAuthenticationProviders[user_1.AuthenticationProvider.AzureActiveDirectory] = com.microsoft.windowsazure.mobileservices.authentication.MobileServiceAuthenticationProvider.WindowsAzureActiveDirectory;
nativeAuthenticationProviders[user_1.AuthenticationProvider.Google] = com.microsoft.windowsazure.mobileservices.authentication.MobileServiceAuthenticationProvider.Google;
nativeAuthenticationProviders[user_1.AuthenticationProvider.Facebook] = com.microsoft.windowsazure.mobileservices.authentication.MobileServiceAuthenticationProvider.Facebook;
nativeAuthenticationProviders[user_1.AuthenticationProvider.Twitter] = com.microsoft.windowsazure.mobileservices.authentication.MobileServiceAuthenticationProvider.Twitter;
nativeAuthenticationProviders[user_1.AuthenticationProvider.MicrosoftAccount] = com.microsoft.windowsazure.mobileservices.authentication.MobileServiceAuthenticationProvider.MicrosoftAccount;
var MobileServiceClient = (function (_super) {
    __extends(MobileServiceClient, _super);
    function MobileServiceClient(url) {
        var _this = _super.call(this, url) || this;
        var androidApp = application.android;
        var context = androidApp.currentContext
            || androidApp.foregroundActivity
            || androidApp.startActivity; // Paranoia checks as we do not what will be initialized in {N} 3.4+
        _this._msClient = new com.microsoft.windowsazure.mobileservices.MobileServiceClient(url, context);
        _this._msClient.setAndroidHttpClientFactory(new com.microsoft.windowsazure.mobileservices.http.OkHttpClientFactory({
            createOkHttpClient: function () {
                var client = new com.squareup.okhttp.OkHttpClient();
                client.setReadTimeout(20, java.util.concurrent.TimeUnit.SECONDS);
                client.setWriteTimeout(20, java.util.concurrent.TimeUnit.SECONDS);
                return client;
            }
        }));
        _this.push = new push_1.MobileServicePush(_this._msClient.getPush());
        return _this;
    }
    MobileServiceClient.prototype.getTable = function (tableName) {
        return new table_1.MobileServiceTable(this._msClient.getTable(tableName));
    };
    MobileServiceClient.prototype.handleActivityResult = function (intent) {
        var result = this._msClient.onActivityResult(intent);
        if (result.isLoggedIn()) {
            return Promise.resolve(new user_1.MobileServiceUser(this._msClient.getCurrentUser(), this._url));
        }
        return Promise.reject(result.getErrorMessage());
    };
    ;
    MobileServiceClient.prototype.login = function (provider, urlScheme) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            try {
                _this._msClient.login(nativeAuthenticationProviders[provider], urlScheme, provider);
                resolve();
            }
            catch (e) {
                reject(e);
            }
        });
    };
    MobileServiceClient.prototype.loginFromCache = function () {
        var user = user_1.MobileServiceUser.getFromCache();
        if (!user) {
            return false;
        }
        this.user = user;
        this._msClient.setCurrentUser(this.user.nativeValue);
        return true;
    };
    return MobileServiceClient;
}(common.MobileServiceClient));
exports.MobileServiceClient = MobileServiceClient;
