"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ClientAuthAppDelegate = ClientAuthAppDelegate_1 = (function (_super) {
    __extends(ClientAuthAppDelegate, _super);
    function ClientAuthAppDelegate() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ClientAuthAppDelegate.setAzureConfig = function (msClient, urlScheme) {
        this._msClient = msClient;
        this._urlScheme = urlScheme;
    };
    ;
    // iOS >= 10
    ClientAuthAppDelegate.prototype.applicationOpenURLOptions = function (application, url, options) {
        return this.handleIncomingUrl(url);
    };
    // iOS < 10
    ClientAuthAppDelegate.prototype.applicationOpenURLSourceApplicationAnnotation = function (application, url, sourceApplication, annotation) {
        return this.handleIncomingUrl(url);
    };
    ;
    ClientAuthAppDelegate.prototype.handleIncomingUrl = function (url) {
        if (!ClientAuthAppDelegate_1._msClient || !ClientAuthAppDelegate_1._urlScheme) {
            // the delegate wasn't wired to the msClient, that should have resulted in an errormessage already
            console.log("IMPORTANT: Could not complete Azure login flow. Please check previous messages.");
            return false;
        }
        if (url.scheme.toLowerCase() === ClientAuthAppDelegate_1._urlScheme) {
            ClientAuthAppDelegate_1._msClient.resumeWithURL(url);
            return true;
        }
        else {
            return false;
        }
    };
    return ClientAuthAppDelegate;
}(UIResponder));
ClientAuthAppDelegate = ClientAuthAppDelegate_1 = __decorate([
    ObjCClass(UIApplicationDelegate)
], ClientAuthAppDelegate);
exports.ClientAuthAppDelegate = ClientAuthAppDelegate;
var ClientAuthAppDelegate_1;
