"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
/*! *****************************************************************************
Copyright (c) 2016 Tangra Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
***************************************************************************** */
var common = require("./query-common");
var utils = require("../utils");
var definition = require("../query");
__export(require("./query-common"));
var MobileServiceQuery = (function (_super) {
    __extends(MobileServiceQuery, _super);
    function MobileServiceQuery() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MobileServiceQuery.prototype.read = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            try {
                var futureResult = _this._msQuery.execute();
                utils.futureToPromise(futureResult).then(function (result) { resolve(utils.getJsObject(result)); }, reject);
            }
            catch (e) {
                reject(e);
            }
        });
    };
    MobileServiceQuery.prototype.field = function (fieldName) {
        this._msQuery.field(fieldName);
        return this;
    };
    MobileServiceQuery.prototype.eq = function (value) {
        this._msQuery.eq(utils.getNativeValueForComparison(value));
        return this;
    };
    MobileServiceQuery.prototype.ne = function (value) {
        this._msQuery.ne(utils.getNativeValueForComparison(value));
        return this;
    };
    MobileServiceQuery.prototype.gt = function (value) {
        this._msQuery.gt(utils.getNativeValueForComparison(value));
        return this;
    };
    MobileServiceQuery.prototype.ge = function (value) {
        this._msQuery.ge(utils.getNativeValueForComparison(value));
        return this;
    };
    MobileServiceQuery.prototype.lt = function (value) {
        this._msQuery.lt(utils.getNativeValueForComparison(value));
        return this;
    };
    MobileServiceQuery.prototype.le = function (value) {
        this._msQuery.le(utils.getNativeValueForComparison(value));
        return this;
    };
    MobileServiceQuery.prototype.startsWith = function (field, value) {
        this._msQuery.startsWith(field, value);
        return this;
    };
    MobileServiceQuery.prototype.endsWith = function (field, value) {
        this._msQuery.endsWith(field, value);
        return this;
    };
    MobileServiceQuery.prototype.and = function () {
        this._msQuery.and();
        return this;
    };
    MobileServiceQuery.prototype.or = function () {
        this._msQuery.or();
        return this;
    };
    MobileServiceQuery.prototype.orderBy = function (field, dir) {
        var nativeDirection = dir === definition.SortDir.Asc ?
            com.microsoft.windowsazure.mobileservices.table.query.QueryOrder.Ascending :
            com.microsoft.windowsazure.mobileservices.table.query.QueryOrder.Descending;
        this._msQuery.orderBy(field, nativeDirection);
        return this;
    };
    MobileServiceQuery.prototype.skip = function (count) {
        this._msQuery.skip(count);
        return this;
    };
    MobileServiceQuery.prototype.top = function (count) {
        this._msQuery.top(count);
        return this;
    };
    return MobileServiceQuery;
}(common.MobileServiceQuery));
exports.MobileServiceQuery = MobileServiceQuery;
