"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
/*! *****************************************************************************
Copyright (c) 2016 Tangra Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
***************************************************************************** */
var common = require("./user-common");
var applicationSettings = require("application-settings");
__export(require("./user-common"));
var MobileServiceUser = (function (_super) {
    __extends(MobileServiceUser, _super);
    function MobileServiceUser(nativeValue, portalUrl) {
        var _this = _super.call(this, nativeValue, portalUrl) || this;
        if (nativeValue) {
            _this.userId = nativeValue.userId;
            _this.authenticationToken = nativeValue.mobileServiceAuthenticationToken;
            _this._cacheAuthenticationInfo();
        }
        return _this;
    }
    MobileServiceUser.getFromCache = function () {
        var userId = applicationSettings.getString(common.MobileServiceUser.USER_ID_CACHE_KEY, null);
        var authenticationToken = applicationSettings.getString(common.MobileServiceUser.AUTHENTICATION_TOKEN_CACHE_KEY, null);
        var portalUrl = applicationSettings.getString(common.MobileServiceUser.PORTAL_URL_CACHE_KEY, null);
        if (userId === null || authenticationToken === null || portalUrl === null) {
            return null;
        }
        var nativeValue = new MSUser({ userId: userId });
        nativeValue.mobileServiceAuthenticationToken = authenticationToken;
        return new MobileServiceUser(nativeValue, portalUrl);
    };
    return MobileServiceUser;
}(common.MobileServiceUser));
exports.MobileServiceUser = MobileServiceUser;
